# Class CompanionDevice

java.lang.Object
com.codename1.nearby.companion.CompanionDevice

public final class CompanionDevice extends Object

A device this app is associated with.

An association outlives the app: it is stored by the OS, survives restarts, and is what makes background presence notifications and permission-free scanning possible. It ends when the app calls `CompanionDevices.disassociate(String)`, when the user revokes it in system settings, or when the app is uninstalled.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `CompanionDevice(String id, String displayName, String address, CompanionProfile profile, boolean present)`
  Ports construct these; application code reads them from `CompanionDevices`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `String`
  `getAddress()`
  The device address, or `null` where the platform does not hand it out.
  `String`
  `getDisplayName()`
  The name to show a user.
  `String`
  `getId()`
  The association id, stable across app restarts.
  `CompanionProfile`
  `getProfile()`
  The profile this association was made under.
  `int`
  `hashCode()`
  Returns a hash code value for the object.
  `boolean`
  `isPresent()`
  Whether the device was in range when this record was produced.
  `String`
  `toString()`
  Returns a string representation of the object.

  ### Methods inherited from class Object

  `clone, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### CompanionDevice

    public CompanionDevice(String id, String displayName, String address, CompanionProfile profile, boolean present)

    Ports construct these; application code reads them from `CompanionDevices`.

    ###### Parameters

    - `id`: the platform's association id
    - `displayName`: the name to show a user, never null
    - `address`: the device address, or null when the platform withholds it
    - `profile`: the profile the association was made under
    - `present`: whether the device is in range right now

- ## Method Details

  - ### getId

    public String getId()
    The association id, stable across app restarts. This is what `CompanionDevices.disassociate(String)` and `CompanionDevices.startObservingPresence(String)` take, and what to persist.

  - ### getDisplayName

    public String getDisplayName()
    The name to show a user. Never null, occasionally empty where the device advertises none.

  - ### getAddress

    public String getAddress()

    The device address, or `null` where the platform does not hand it out. Where it is present it matches `com.codename1.bluetooth.BluetoothDevice#getAddress()`, so it can be passed to `BluetoothLE.getPeripheral(String)` to open a GATT connection to the associated device.

    Android returns the MAC address for a Bluetooth association. iOS returns the per-app accessory identifier.

  - ### getProfile

    public CompanionProfile getProfile()
    The profile this association was made under.

  - ### isPresent

    public boolean isPresent()

    Whether the device was in range when this record was produced.

    This is a snapshot, not a live value -- re-read it from `CompanionDevices.getAssociations()`, or watch `PresenceListener` for changes. Platforms that do not track presence report `false`.

  - ### equals

    public boolean equals(Object o)
    Description copied from class: `Object`
    Indicates whether some other object is "equal to" this one. The equals method implements an equivalence relation: It is reflexive: for any reference value x, x.equals(x) should return true. It is symmetric: for any reference values x and y, x.equals(y) should return true if and only if y.equals(x) returns true. It is transitive: for any reference values x, y, and z, if x.equals(y) returns true and y.equals(z) returns true, then x.equals(z) should return true. It is consistent: for any reference values x and y, multiple invocations of x.equals(y) consistently return true or consistently return false, provided no information used in equals comparisons on the object is modified. For any non-null reference value x, x.equals(null) should return false. The equals method for class Object implements the most discriminating possible equivalence relation on objects; that is, for any reference values x and y, this method returns true if and only if x and y refer to the same object (x==y has the value true).
    Overrides:
      `equals` in class `Object`

  - ### hashCode

    public int hashCode()
    Description copied from class: `Object`
    Returns a hash code value for the object. This method is supported for the benefit of hashtables such as those provided by java.util.Hashtable. The general contract of hashCode is: Whenever it is invoked on the same object more than once during an execution of a Java application, the hashCode method must consistently return the same integer, provided no information used in equals comparisons on the object is modified. This integer need not remain consistent from one execution of an application to another execution of the same application. If two objects are equal according to the equals(Object) method, then calling the hashCode method on each of the two objects must produce the same integer result. It is not required that if two objects are unequal according to the equals(java.lang.Object) method, then calling the hashCode method on each of the two objects must produce distinct integer results. However, the programmer should be aware that producing distinct integer results for unequal objects may improve the performance of hashtables. As much as is reasonably practical, the hashCode method defined by class Object does return distinct integers for distinct objects. (This is typically implemented by converting the internal address of the object into an integer, but this implementation technique is not required by the JavaTM programming language.)
    Overrides:
      `hashCode` in class `Object`

  - ### toString

    public String toString()
    Description copied from class: `Object`
    Returns a string representation of the object. In general, the toString method returns a string that "textually represents" this object. The result should be a concise but informative representation that is easy for a person to read. It is recommended that all subclasses override this method. The toString method for class Object returns a string consisting of the name of the class of which the object is an instance, the at-sign character `@', and the unsigned hexadecimal representation of the hash code of the object. In other words, this method returns a string equal to the value of: getClass().getName() + '@' + Integer.toHexString(hashCode())
    Overrides:
      `toString` in class `Object`